'use strict';
var mysql = require('@gopalroy/mysql-pool');
var core  = require('@gopalroy/biz-core');
var Entity = core.Entity;
var m = AppVersionService;

/*
 CREATE TABLE `t_app` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `short_name` varchar(45) DEFAULT NULL,
 `name` varchar(45) DEFAULT NULL,
 `app_type` int(11) DEFAULT '1' COMMENT '1： 安卓, 2: IOS, 3: 车机',
 `description` varchar(255) DEFAULT NULL,
 `created_at` datetime DEFAULT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `short_name_UNIQUE` (`short_name`)
 );

 CREATE TABLE `t_app_ver` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `short_name` varchar(45) DEFAULT NULL,
 `version` varchar(45) DEFAULT NULL,
 `published_time` datetime DEFAULT NULL,
 `file_path` varchar(255) DEFAULT NULL,
 `file_size` int(11) DEFAULT '0',
 `description` varchar(255) DEFAULT NULL,
 PRIMARY KEY (`id`)
 );
 */

function AppVersionService(){}

m.addAppG = function*(app) {
    var result = yield Entity.commonInsertG('t_app', app);
    return result.insertId;
};

m.addVersionG = function*(version) {
    var result = yield Entity.commonInsertG('t_app_ver', version);
    return result.insertId;
};

m.deleteAppG = function*(id) {
    yield mysql.pool.queryP('DELETE ROM t_app where id = ?', [id]);
};

m.deleteVersionG = function*(id) {
    yield mysql.pool.queryP('DELETE FROM t_app_ver where id = ?', [id]);
};

m.getAppsG = function*(filter, sortBy, pageSize, nextMarker) {
    var query = Entity.assemblyPagingSQL('t_app', filter, sortBy, pageSize, nextMarker);
    return yield mysql.pool.queryP(query.sql, query.args);
};

m.getAppsCountG = function*(filter) {
    var query = Entity.assemblyPagingSQL('t_app', filter);
    var rows = yield mysql.pool.queryP(query.sqlCount, query.args);
    return rows[0].rowsCount;
};

m.getVersionsG = function*(filter, pageSize, nextMarker) {
    var query = Entity.assemblyPagingSQL('t_app_ver', filter, 'id-', pageSize, nextMarker);
    return yield mysql.pool.queryP(query.sql, query.args);
};

m.getVersionsCountG = function*(filter) {
    var query = Entity.assemblyPagingSQL('t_app_ver', filter);
    var rows = yield mysql.pool.queryP(query.sqlCount, query.args);
    return rows[0].rowsCount;
};

module.exports = m;
