'use strict';
var moment = require('moment');
var mysql  = require('@gopalroy/mysql-pool');
var core   = require('@gopalroy/biz-core');
var ApiHelpler = require('./ApiHelper');
var Entity = core.Entity;
var m      = TrackService;

/*
 CREATE TABLE `t_track_record` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `obd_code` varchar(20) DEFAULT NULL,
 `trip_id` int(11) DEFAULT NULL,
 `start_time` datetime DEFAULT NULL,
 `end_time` datetime DEFAULT NULL,
 `start_mileage` int(11) DEFAULT 0,
 `end_mileage` int(11) DEFAULT 0,
 `trip_ended` tinyint(1) DEFAULT 0,
 PRIMARY KEY (`id`)
 );
 */

function TrackService() {
}

m.fromIdG = function*(id) {
    return (yield mysql.pool.queryP('select * from t_track_record where id = ?', [id]))[0];
};

m.addTrackG = function*(track) {
    var result = yield Entity.commonInsertG('t_track_record', track);
    return result.insertId;
};

m.endTrackG = function*(trackId) {
    return yield mysql.pool.queryP('update t_track_record set status = 1 where id = ?', [trackId]);
};

m.getTracksG = function*(filter, sortBy, pageSize, nextMarker) {
    var query = Entity.assemblyPagingSQL('t_track_record', filter, sortBy, pageSize, nextMarker);
    return yield mysql.pool.queryP(query.sql, query.args);
};

m.getTracksCountG = function*(filter) {
    var query = Entity.assemblyPagingSQL('t_track_record', filter);
    var rows  = yield mysql.pool.queryP(query.sqlCount, query.args);
    return rows[0].rowsCount;
};

m.deleteTrack = function*(id) {
    return yield mysql.pool.queryP('DELETE FROM t_track_record WHERE id = ?', [id]);
};

m.refreshEndTime = function*(id) {
    return yield mysql.pool.queryP('UPDATE t_track_record SET end = ? WHERE id = ?', [moment().format('YYYY-MM-DD HH:mm:ss'), id]);
};

m.update = function*(filter, values) {
    yield ApiHelpler.batchUpdateG('t_track_record', filter, values);
};

module.exports = m;
