'use strict';
var co         = require('co');
var express    = require('express');
var Authority  = require('./Authority');
var mysql      = require('@gopalroy/mysql-pool');
var VehicleAPI = require('@gopalroy/eightymiles/api/VehicleAPI');

var m = VehicleApi;
function VehicleApi() {
}

m.context = '/';

m.getUserRouter = function () {
    if (!this.userRouter) {
        var router      = new express();
        this.userRouter = router;
        router.post('/vehicle/bind', VehicleAPI.value.bind);//用户绑定车辆
        router.get('/vehicle/checkObdCode/:obdCode', VehicleAPI.value.checkObdCode);
        router.get('/vehicle/checkLicense/:license', VehicleAPI.value.checkLicense);
        router.post('/vehicle/unbind', VehicleAPI.value.unbind);//用户解绑车辆
        router.get('/vehicle', Authority.resolveVehicle, VehicleAPI.value.get);//获取用户车辆信息
        router.post('/vehicle', Authority.resolveVehicle, VehicleAPI.value.update);//更新用户车辆信息
    }

    return this.userRouter;
};

m.getStaffRouter = function () {
    if (!this.staffRouter) {
        var router       = new express();
        this.staffRouter = router;
        router.get('/vehicle/:vehicleId(\\d+)', this.getDetail);
    }

    return this.staffRouter;
};

m.getDetail = function (req, res) {
    var id = req.params.vehicleId;
    co(function*() {
        var result = yield mysql.pool.queryP('SELECT C.*, U.*, U.id as user_id, C.id as car_id FROM t_car C LEFT JOIN t_car_user CU ON C.id = CU.car_id ' +
            'LEFT JOIN t_account U ON U.id = CU.acc_id and U.s4_id = CU.s4_id WHERE C.id = ?', [id]);
        if (result[0]) result[0].id = result[0].car_id;
        return res.json({status: 'success', vehicle: result[0] || null});
    }).catch(ex => {
        res.status(500).json({status: 'failed', errorNo: 'SYSTEM_EXCEPTION', error: ex.message});
        console.log(__filename, ex.stack);
    });
};

module.exports = m;
