'use strict';
var express = require('express');
var bulk    = require('bulk-require');

var modules = bulk(__dirname, ['./!(*index|*.spec).js']),
    m       = WiseCarAPI;

function WiseCarAPI() {
}

m.context = '/';

m.getStaffRouter =
    function () {
        if (!this.staffRouter) {
            this.staffRouter = _loadRouter('getStaffRouter');
        }
        return this.staffRouter;
    };

m.getUserRouter =
    function () {
        if (!this.userRouter) {
            this.userRouter = _loadRouter('getUserRouter');
        }
        return this.userRouter;
    };

m.getApi =
    function () {
        if (!this.api) {
            this.api = {};
            Object.keys(modules).forEach(key => {
                !!modules[key]['name'] && (this.api[modules[key]['name']] = modules[key]);
            });
        }
        return this.api;
    };

function _loadRouter(routeFn) {
    var router = new express();
    Object.keys(modules).forEach(key => {
        if (modules[key][routeFn]) {
            router.use(modules[key]['context'], modules[key][routeFn]());
        }
    });
    return router;
}

module.exports = m;