/**
 * Created by dave on 16/4/25 09:22.
 */
'use strict';
var express = require('express');
var moment  = require('moment');
var WiseCar = require('./api');
var authority = new WiseCar.getApi().Authority.wisecar;

// TODO 正式发布时删除下面一行.
process.env.WiseCar_ENV = 'TEST';

var app               = new express();
Date.prototype.toJSON = function () {
    return moment(this).format('YYYY-MM-DD HH:mm:ss');
};
app.all('/*', function(req, res, next) {
    res.header("Access-Control-Allow-Origin", '*');
    next();
});
app.post('/api/web/staff/login', WiseCar.getApi().StaffApi.login);
app.use('/api/mobile', authority.checkUserToken, WiseCar.getUserRouter());
app.use('/api/pub', WiseCar.getApi().PubApi.getPubRouter());
app.use('/api/web', authority.checkStaffToken, WiseCar.getStaffRouter());
app.use('/asset',      express.static(__dirname + '/web/asset'));
app.all('/*', function(req, res, next) {
    if (req.path.indexOf('/api') >= 0) {
        next();
    } else {
        res.sendFile(__dirname + '/web/index.html');
    }
});

module.exports = app;