export default function routeConfig($locationProvider, $urlRouterProvider, $stateProvider, templateProvider) {
    const templateCache = templateProvider.$get();

    $locationProvider.html5Mode(true);
    $urlRouterProvider.otherwise('/');
    $stateProvider
        .state('home', {
            url       : '/',
            controller: 'LoginCtrl',
            template  : templateCache.LoginCtrl,
        })
        .state('console', {
            url       : '/console',
            controller: 'ConsoleCtrl',
            template  : templateCache.ConsoleCtrl,
        })
        .state('console.home', {
            url       : '/home',
            controller: 'HomeCtrl',
            template  : templateCache.HomeCtrl,
        })
        .state('console.vehicle', {
            url       : '/vehicle',
            controller: 'UserCtrl',
            template  : templateCache.UserCtrl,
        })
        .state('console.vehicle.detail', {
            url       : '/{id:\\d+}',
            controller: 'VehicleCtrl',
            template  : templateCache.VehicleCtrl,
        })
        .state('console.app', {
            url       : '/app',
            controller: 'AppCtrl',
            template  : templateCache.AppCtrl,
        })
        .state('console.app.detail', {
            url       : '/{short_name}',
            controller: 'AppDetailCtrl',
            template  : templateCache.AppDetailCtrl,
        });
}

routeConfig.$inject = ['$locationProvider', '$urlRouterProvider', '$stateProvider', 'templateProvider'];
