import {Injector} from 'ngES6';
import './console.scss';

export default class ConsoleCtrl extends Injector {
    static $inject = ['$scope', '$state', '$http', 'AccountService'];
    static $template = require('./console.html');

    constructor(...args) {
        super(...args);
        const {$scope, $state} = this.$injected;
        this.attachMethodsTo($scope);
        if ($state.is('console')) {
            $state.go('console.home');
        }
    }

    logout() {
        this.$injected.$http.get('/wservice/logout').then(function(res) {
            if (res.data.status === 'ok') {
                window.location.href = '/';
            }
        });
    }
}
