import {Injector} from 'ngES6';
import './login.scss';

export default class LoginCtrl extends Injector {
    static $inject = ['$scope', '$state', 'AccountService'];
    static $template = require('./login.html');

    constructor(...args) {
        super(...args);
        const {$scope} = this.$injected;
        this.attachMethodsTo($scope);
    }

    login() {
        const {$scope, $state, AccountService} = this.$injected;
        const {username, password} = $scope;
        AccountService.login(username, password).then(res => {
            if (res.data) {
                if (res.data.status !== 'success') $scope.msg = res.data.error;
                else $state.go('console.vehicle');
            } else {
                $scope.msg = '访问网络失败';
            }
        });
    }
}
