import {Injector} from 'ngES6';
import './user.scss';

export default class UserCtrl extends Injector {
    static $inject = ['$scope', '$state', 'UserService'];
    static $template = require('./user.html');

    constructor(...args) {
        super(...args);
        const {$scope} = this.$injected;
        this.attachMethodsTo($scope);
        $scope.filter = {};
        $scope.pager = {page: 1, totalItems: 0, pageSize: 15};
        this.getUsers();
    }

    getUsers() {
        const {$scope, UserService} = this.$injected;
        const {page, pageSize} = $scope.pager;
        UserService.search($scope.filter, page, pageSize).then(res => {
            if (res.data) {
                if (res.data.status === 'success') {
                    $scope.users = res.data.users;
                    $scope.pager.totalItems = res.data.total;
                } else {
                    console.log(res.data);
                }
            }
        });
    }

    reset() {
        this.$injected.$scope.filter = {};
    }
}
