import {Injector} from 'ngES6';

export default class UserService extends Injector {
    static $inject = ['$http', 'Settings'];

    search(filter, page, pageSize) {
        const {$http, Settings} = this.$injected;
        return $http.get(Settings.domain + '/api/web/user', {
            params: {...filter, pageSize: pageSize, nextMarker: (page - 1) * pageSize + 1},
        });
    }

    getDetail(id) {
        const {$http, Settings} = this.$injected;
        return $http.get(Settings.domain + '/api/web/user/' + id);
    }
}
